(*  This unit uses the HTTP control from Indy (WinShoes 8).
    You can get Indy free from http://www.nevrona.com/indy/
    It's an excellent set of open-source components which
    will be included with Delphi 6 and Kylix.  The Indy
    HTTP component is only used for retrieving URL info
    from one of DC's URL servers; if you don't care about
    doing that you may comment out the references to
    idHTTP1 and all id* libraries in the Uses clause.

    The SendKey unit also listed in the Uses clause is used
    to send keystrokes to another application.  It is
    available seperately from www.kickme.to/delphicat,
    as is the Kittycat unit which handles reading the
    Cat Poop.

    REVISION HISTORY

    v0.10 - Initial release
    v0.11 - Added the ability to decode a barcode and send its
            data to the active window.  If LitterBox is minimized,
            it will restore itself, capture the Cat Poop, decode it,
            activate the window that was active before, then send the
            decoded barcode to it.  To test, open Litterbox, check the
            box to "Send barcode text to foreground application" then
            minimize it.  Open notepad, and make sure it's the topmost
            window.  Scan in a barcode, and wow! the code appears in
            notepad.  Ooohh, ahhh...  This functionality requires the
            SendKey unit available from my page...
*)

unit Catlaunch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,kittycat, shellapi, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,sendkey, Menus;


type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    edtURL: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button2: TButton;
    Edit4: TEdit;
    Button3: TButton;
    memBody: TMemo;
    Edit3: TEdit;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    IdHTTP1: TIdHTTP;
    cbSendkeys: TCheckBox;
    btnEncode: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cbSendkeysClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure btnEncodeClick(Sender: TObject);
  private
    procedure WMHotKey(var Message: TMessage); message WM_HOTKEY;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TopWind :hwnd;

implementation

{$R *.DFM}

procedure OpenObject( sObjectPath : string );
begin
  ShellExecute( 0, Nil, PChar( sObjectPath ),
                 Nil, Nil, SW_NORMAL );
end;

procedure Tform1.WMHotKey(var Message: TMessage);
 begin
  topWind := GetforegroundWindow; // may need this later
  application.Restore;  // if minimized, restore this app
  application.bringtofront;  // give our app focus
  application.processmessages;

  //showmessage('CTRL-F7 pressed!');  // message the user
 end;

function RevCase(str:string):string;
var x : integer;
    ch : char;
begin
  result := '';
  setlength(result,length(str));
  for x := 1 to length(str) do
   begin
      ch := str[x];
      if (ch in ['A'..'Z']) then
        ch := chr(ord(ch)+32)
      else
        if (ch in ['a'..'z']) then
         ch := chr(ord(ch)-32);
      result[x] := ch;
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var ser,bc,bctype : string;
begin     
  ser := '000000000000031337';  // let's give them an "elite" serial number  :)
  bc := extractbarcode(edit1.text);
  bctype := extractcodetype(edit1.text);
  edit2.text := revcase(makecatpoop(ser,bctype,bc));  // look ma, privacy!
  edtURL.text := makeurl('a.dcnv.com','ACTIVATIONCode',edit1.text,false);
  edit4.text := extractbarcode(edit1.text);
  edit5.text := extractcodetype(edit1.text);
  edit3.text := extractserial(edit1.text);
  edit1.setfocus;
  edit1.selectall;
  application.processmessages;
  end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  RegisterHotKey(form1.Handle,123,mod_alt,vk_f10);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if key = #13 then
   begin
     edit1.SelectAll;
     if cbSendKeys.checked then
       begin
         setforegroundwindow(topwind);
         sendkeys(extractbarcode(edit1.text),topwind);
         sendkeysex('{ENTER}',topwind);
       end
     else
       begin
         Button1Click(Self);
         Button3Click(Self);
       end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  ssResult: TStringStream;
  x : integer;
  LaunchURL : string;
begin
  if edtUrl.text = '' then
    begin
      showmessage('No URL is available to launch.  Decode a barcode first!');
      exit;
    end;
  Screen.Cursor := crHourGlass;
  try
    ssResult := TStringStream.Create('');
    try
      with idHTTP1 do begin
        Get(edtURL.Text, ssResult);
        memBody.Text := AdjustLineBreaks(ssResult.DataString);
      end;
    finally
      ssResult.Free;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  for x := 0 to memBody.lines.count do
   if pos('url=',membody.lines[x]) > 0 then
    begin
      launchURL := memBody.lines[x];
      delete(launchURL,1,4);
      OpenObject( launchURL );
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit4.SelectAll;
  Edit4.CopyToClipboard;
end;

procedure TForm1.cbSendkeysClick(Sender: TObject);
begin
  edit1.setfocus;  // make sure edit 1 always receives input
  edit1.selectall; // and existing data will be cleared
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  edit1.setfocus;
  edit1.selectall;

end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.btnEncodeClick(Sender: TObject);
begin
   if (edit3.text <> '') and  (edit5.text <> '') and (edit4.text <> '') then
    begin
      edit1.clear;
      edit1.text := makecatpoop(edit3.text,edit5.text,edit4.text);
    end
   else
     showmessage('You need to put in data for serial, code type and barcode first!');
end;

end.
